#!/bin/sh
# $Id: pipelight.SlackBuild,v 1.20 2014/12/22 16:51:11 root Exp root $
# Copyright 2013, 2014, 2016  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         pipelight
# Descr:       wine-based Silverlight plugin for Linux browsers
# URL:         http://fds-team.de/
# Needs:       multilib,wine-pipelight,webcore-fonts-installer
# Changelog:   
# 0.2.1-1:     03/nov/2013 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 0.2.1-2:     14/nov/2013 by Eric Hameleers <alien@slackware.com>
#              * Update the install-dependencies script: pushes Flash to
#                newest version 11.9.900.152 (* Security fix *)
# 0.2.2-1:     15/nov/2013 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.6.
# 0.2.3-1:     14/dec/2013 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.8.
# 0.2.4-1:     19/jan/2014 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.11.
# 0.2.4.2-1:   20/jan/2014 by Eric Hameleers <alien@slackware.com>
#              * After a manual update, patch the install-dependency script
#                to use Slackware's version of mktemp.
# 0.2.5-1:     22/feb/2014 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.13.
# 0.2.6-1:     08/apr/2014 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.16. On 64-bit
#                Slackware, enable 64-bit Wine plugin support.
# 0.2.7-1:     03/jun/2014 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.19.
# 0.2.8-1:     22/dec/2014 by Eric Hameleers <alien@slackware.com>
#              * Update, together with wine-pipelight 1.7.33.
# 0.2.8.2-1:   29/jul/2016 by Eric Hameleers <alien@slackware.com>
#              * Updated release and 'install-dependencies' script.
#                Also stop requiring a separate 'wine-pipelight' package,
#                now that the regular wine package already has the
#                'wine-staging' patches applied.
#                From now on, pipelight will use the regular wine.
# 
# Run 'sh pipelight.SlackBuild' to build a Slackware package.
# The package (.tgz) and .txt file as well as build logs are created in /tmp .
# Install it using 'installpkg'. 
#
# -----------------------------------------------------------------------------

PRGNAM=pipelight
VERSION=${VERSION:-0.2.8.2}
TRUNKVERSION=$(echo $VERSION | cut -f1,2 -d'.')
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:" -j4 "}
TAG=${TAG:-alien}

# If you do not want wine64 on Slackware64, set this to "no".
# Be sure to match this setting with the wine-pipelight build!
DO_WINE64=${DO_WINE64:-"yes"}

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Need to refresh the 'install-dependencies' script?
UPDATE_SCRIPT=${UPDATE_SCRIPT:-"YES"}

# Where did we install wine (with wine-staging patches) for pipelight?
WPREFIX="/usr"

DOCS="LICENSE README wine-patches/README $SRCDIR/LICENSE.pluginloader-prebuilt"

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

SOURCE[0]="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
SRCURL[0]="https://bitbucket.org/mmueller2012/${PRGNAM}/get/v${VERSION}.tar.gz"

SOURCE[1]="$SRCDIR/pluginloader-v${VERSION}.tar.gz"
SRCURL[1]="http://repos.fds-team.de/pluginloader/v${VERSION}/pluginloader.tar.gz"

SOURCE[2]="$SRCDIR/pluginloader-v${VERSION}.tar.gz.sig"
SRCURL[2]="http://repos.fds-team.de/pluginloader/v${VERSION}/pluginloader.tar.gz.sig"

SOURCE[3]="$SRCDIR/LICENSE.pluginloader-prebuilt"
SRCURL[3]="https://bitbucket.org/mmueller2012/pipelight/raw/v${VERSION}/debian/copyright"

if [ "$UPDATE_SCRIPT" != "NO" ]; then
  rm -f $SRCDIR/install-dependency-HEAD
  SOURCE[3]="$SRCDIR/install-dependency-HEAD"
  SRCURL[3]="https://bitbucket.org/mmueller2012/pipelight/raw/master/share/install-dependency"
fi

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
MARCH=$( uname -m )
if [ -z "$ARCH" ]; then
  case "$MARCH" in
    i?86)    export ARCH=i486 ;;
    armv7hl) export ARCH=$MARCH ;;
    arm*)    export ARCH=arm ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *)       export ARCH=$MARCH ;;
  esac
fi

case "$ARCH" in
  i486)      SLKCFLAGS="-O2 -march=i486 -mtune=i686"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"O2"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

if [ "$ARCH" = "x86_64" -a "$DO_WINE64" = "yes" ]; then
  ARCH_OPTS="--win32-prebuilt --win64-prebuilt --with-win64 --wine64-path=$WPREFIX/bin/wine64"
else
  ARCH_OPTS="--win32-prebuilt"
fi

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
  if ! [ -f ${SOURCE[$i]} ]; then
    echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
    # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
    [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
    if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
    if ! [ "x${SRCURL[$i]}" == "x" ]; then
      echo "Will download file to $(dirname $SOURCE[$i])"
      wget -nv -T 20 -O "${SOURCE[$i]}" "${SRCURL[$i]}" || true
      if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
        echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
        mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
        exit 1
      fi
    else
      echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
      exit 1
    fi
  fi
done

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xvf ${SOURCE[0]}
mv mmueller2012-pipelight-* ${PRGNAM}-${VERSION}
# The "make install" will verify and unpack the binaries:
cp ${SOURCE[1]} ${SOURCE[2]} ${PRGNAM}-${VERSION}/

cd ${PRGNAM}-${VERSION}

if [ "$UPDATE_SCRIPT" != "NO" ]; then
  # Replace the install-dependency script with an uptodate version:
  if [ -f $SRCDIR/install-dependency-HEAD ]; then
    cat $SRCDIR/install-dependency-HEAD > share/install-dependency
  fi
fi

# Slackware specific patches:
# No patches needed.
#touch $OUTPUT/patch-${PRGNAM}.log

chown -R root:root .
chmod -R u+w,go+r-w,a+X-s .

echo Building ...
export LDFLAGS="$SLKLDFLAGS" 
export CXXFLAGS="$SLKCFLAGS"
export CFLAGS="$SLKCFLAGS"
./configure \
  --prefix=/usr \
  --libdir=/usr/lib${LIBDIRSUFFIX} \
  --mandir=/usr/man \
  --moz-plugin-path=/usr/lib${LIBDIRSUFFIX}/mozilla/plugins \
  --wine-path=$WPREFIX/bin/wine \
  --gcc-runtime-dlls="" \
  --show-installation-dialogs \
  ${ARCH_OPTS} \
  2>&1 | tee $OUTPUT/configure-${PRGNAM}.log

make $NUMJOBS \
  2>&1 | tee $OUTPUT/make-${PRGNAM}.log
make DESTDIR=$PKG install \
  2>&1 | tee $OUTPUT/install-${PRGNAM}.log

# Create the doinst.sh script:
mkdir -p $PKG/install
cat <<EOT > $PKG/install/doinst.sh
# Remove copies of the libpipelight.so and re-create them.
# This is needed because of the way Mozilla browsers evaluate the available
# plugins in the plugins directory: multiple soft- and hardlinks
# to the same file will be seen as _one_ plugin, not several.
#
# Browser plugins need to be enabled by the user (non-root) using the command:
#   $ pipelight-plugin --enable <plugin_name>
# for instance if the user wants to use SilverLight:
#   $ pipelight-plugin --enable silverlight5.1
# That will download and install the necessary Windows files, the very first
# time the plugin is loaded by a browser.
#
chroot . pipelight-plugin --remove-mozilla-plugins
chroot . pipelight-plugin --create-mozilla-plugins
EOT

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}

